【codeforces 721C】【DAG 按照拓扑排序记忆化DFS】C. Journey 【DAG图,5000个点,5000条边 让你求从1到n的路径长度不超过T中经过点数最多的一条 】

传送门:C. Journey

描述:

C. Journey
time limit per test
3 seconds
memory limit per test
256 megabytes
input
standard input
output
standard output

Recently Irina arrived to one of the most famous cities of Berland — the Berlatov city. There are n showplaces in the city, numbered from1 to n, and some of them are connected by one-directional roads. The roads in Berlatov are designed in a way such that there are nocyclic routes between showplaces.

Initially Irina stands at the showplace 1, and the endpoint of her journey is the showplace n. Naturally, Irina wants to visit as much showplaces as she can during her journey. However, Irina's stay in Berlatov is limited and she can't be there for more than T time units.

Help Irina determine how many showplaces she may visit during her journey from showplace 1 to showplace n within a time not exceeding T. It is guaranteed that there is at least one route from showplace 1 to showplace n such that Irina will spend no more than Ttime units passing it.

Input

The first line of the input contains three integers n, m and T (2 ≤ n ≤ 5000,  1 ≤ m ≤ 5000,  1 ≤ T ≤ 109) — the number of showplaces, the number of roads between them and the time of Irina's stay in Berlatov respectively.

The next m lines describes roads in Berlatov. i-th of them contains 3 integers ui, vi, ti (1 ≤ ui, vi ≤ n, ui ≠ vi, 1 ≤ ti ≤ 109), meaning that there is a road starting from showplace ui and leading to showplace vi, and Irina spends ti time units to pass it. It is guaranteed that the roads do not form cyclic routes.

It is guaranteed, that there is at most one road between each pair of showplaces.

Output

Print the single integer k (2 ≤ k ≤ n) — the maximum number of showplaces that Irina can visit during her journey from showplace 1 to showplace n within time not exceeding T, in the first line.

Print k distinct integers in the second line — indices of showplaces that Irina will visit on her route, in the order of encountering them.

If there are multiple answers, print any of them.

Examples
input
4 3 13
1 2 5
2 3 7
2 4 8
output
3
1 2 4 
input
6 6 7
1 2 2
1 3 3
3 6 3
2 4 2
4 6 2
6 5 1
output
4
1 2 4 6 
input
5 5 6
1 3 3
3 5 3
1 2 2
2 4 3
4 5 2
output
3
1 3 5 
题意:
DAG图,5000个点,5000条边 

让你求从1到n的路径长度不超过T中经过点数最多的一条

思路:


f[i][j]表示当前在点i,接下来经过j个点(包括自己)到n点的最小距离
nxt[i][j]表示当前在点i,接下来经过j个点(包括自己)到n点的后继 ,这里用short可以优化不少内存

然后 按照拓扑排序记忆化搜索一下

如果我们有x的后继为y
那么我们肯定可以对y做dfs,在对y做dfs的时候,显然不会走到x(DAG图)
换而言之,y的所有可能的前驱(包括前驱的前驱)都不会影响到dfs(y)的值
于是,这里就保证了该dp的正确拓扑序,也就可以在O(n^2)的复杂度内出解。


代码:

#include <bits/stdc++.h>
#define pr(x) cout << #x << "= " << x << "  " ;
#define pl(x) cout << #x << "= " << x << endl;
#define ll __int64
#define mst(ss,b) memset(ss,b,sizeof(ss));
using  namespace  std;
const int N=5050;
const int inf=0x3f3f3f3f;

int n, m, T;
int f[N][N];//f[i][j]表示当前在点i,接下来经过j个点(包括自己)到n点的最小距离
short nxt[N][N];//nxt[i][j]表示当前在点i,接下来经过j个点(包括自己)到n点的后继
vector< pair<int,int> >a[N];
bool vis[N];
void dfs(int x){
  if (vis[x])return; vis[x] = 1;
  for (auto it : a[x]){
    dfs(it.first);
    for (int i = 2; i <= n; ++i){
      int dis = f[it.first][i - 1] + it.second;
      if (dis < f[x][i]){
        f[x][i] = dis;
        nxt[x][i] = it.first;
      }
    }
  }
}

void print(){
  for (int i = n; ; --i)if (f[1][i] <= T){
    printf("%d\n", i);
    int x = 1; printf("%d ", x);
    while (x != n){
      x = nxt[x][i--];
      printf("%d ", x);
    }puts("");
    break;
  }
}

int main(){
  while(~scanf("%d%d%d",&n, &m, &T)){
    for (int i = 1; i <= n; ++i)a[i].clear(), vis[i] = 0;
    for (int i = 1; i <= m; ++i){
      int x, y, z;
      scanf("%d%d%d", &x, &y, &z);
      if (y == 1 || x == n)continue;
      a[x].push_back({ y,z });
    }
    mst(f, inf);
    f[n][1] = 0; vis[n] = 1;
    dfs(1);
    print();
  }
  return 0;
}


  • 0
    点赞
  • 2
    收藏
    觉得还不错? 一键收藏
  • 0
    评论
题目描述 给定一棵 $n$ 个节的树,每个节都有一个权值 $w_i$。你需要删去树上的一些边,使得剩下的每个连通块,所有节的权值之和不超过 $k$。 最多能删去多少条边。 输入格式 第一行包含两个整数 $n,k$。 第二行包含 $n$ 个整数 $w_1,w_2,\cdots,w_n$。 接下来 $n-1$ 行,每行包含两个整数 $a,b$,表示节 $a$ 和节 $b$ 之间有一条边。 输出格式 输出一个整数,表示最多能删去的边数。 数据范围 $1\le n \le 10^5$ $1 \le k,w_i \le 10^9$ 输入样例1: 5 6 2 3 1 5 4 1 2 1 3 2 4 2 5 输出样例1: 2 输入样例2: 5 3 2 3 1 5 4 1 2 1 3 2 4 2 5 输出样例2: 0 算法1 (dfs) $O(n)$ 首先我们可以想到暴力的做法,即对于每个连通块,暴力枚举删去哪些边,尝试得到最多的删边数。那么如何解一个连通块内的所有节权值之和呢?我们可以使用 DFS 遍历树,对于每个节出其子树内所有节的权值之和,那么以该节为根的子树内的所有节权值之和就是该节自身的权值加上其所有子节的权值之和。 对于每个连通块,我们枚举该连通块内任意两个节 $x,y$。如果 $x$ 与 $y$ 之间的路径上的所有边都被删去了,那么 $x$ 和 $y$ 就会分别成为两个新的连通块,这两个新的连通块内所有节的权值之和都不超过 $k$。因此我们只需要枚举所有的 $x,y$ 对,对于每个 $x,y$ 对尝试删去它们之间的路径上的所有边,看是否能够让 $x$ 和 $y$ 成为两个新的连通块,进而更新答案即可。 时间复杂度 参考文献 python3 代码 算法2 (暴力枚举) $O(n^2)$ blablabla 时间复杂度 参考文献 C++ 代码 class Solution { public: const int N = 1e5+10; int n,k; int h[N],e[N<<1],ne[N<<1],idx; int w[N]; int sum[N]; bool st[N]; int res; void add(int a,int b) { e[idx] = b,ne[idx] = h[a],h[a] = idx++; } void dfs(int u,int father) { sum[u] = w[u]; for(int i=h[u];~i;i=ne[i]) { int j = e[i]; if(j == father) continue; dfs(j,u); sum[u] += sum[j]; } } void dfs2(int u,int father) { for(int i=h[u];~i;i=ne[i]) { int j = e[i]; if(j == father) continue; dfs2(j,u); if(sum[j] <= k) res++; else if(sum[u] - sum[j] <= k) res++; } } void solve() { cin >> n >> k; memset(h,-1,sizeof(h)); for(int i=1;i<=n;i++) cin >> w[i]; for(int i=1;i<n;i++) { int a,b; cin >> a >> b; add(a,b); add(b,a); } dfs(1,-1); dfs2(1,-1); cout << res << endl; } }; int main() { Solution().solve(); return 0; }
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值